//
//  $VER: Prop.h        1.2 (02 Sep 1996)
//
//    c 1996 Thomas Wilhelmi
//
//
// Address : Taunusstrasse 14
//           61138 Niederdorfelden
//           Germany
//
//  E-Mail : willi@twi.rhein-main.de
//
//   Phone : +49 (0)6101 531060
//   Fax   : +49 (0)6101 531061
//
//
//  $HISTORY:
//
//  16 Jun 1996 :   1.0 : first public Release
//
//  02 Sep 1996 :   1.2 : Neu:
//                        - Die Methode Decrease() wurde fr MUI 3.6 hinzugefgt.
//                        - Die Methode Increase() wurde fr MUI 3.6 hinzugefgt.
//                        - ClassNum() fr Exception-Handling.
//

#ifndef CPP_TWIMUI_PROP_H
#define CPP_TWIMUI_PROP_H

#ifndef CPP_TWIMUI_GADGET_H
#include <classes/twimui/gadget.h>
#endif

class MUIProp : public MUIGadget
	{
	protected:
		virtual const ULONG ClassNum() const;
	public:
		MUIProp(const struct TagItem *t) : MUIGadget(MUIC_Prop) { init(t); };
		MUIProp(const Tag, ...);
		MUIProp() : MUIGadget(MUIC_Prop) { };
		MUIProp(const MUIProp &);
		virtual ~MUIProp();
		MUIProp &operator= (const MUIProp &);
		void Entries(const LONG p) { set(MUIA_Prop_Entries,(ULONG)p); };
		LONG Entries() const { return((LONG)get(MUIA_Prop_Entries,0L)); };
		void First(const LONG p) { set(MUIA_Prop_First,(ULONG)p); };
		LONG First() const { return((LONG)get(MUIA_Prop_First,0L)); };
		BOOL Horiz() const { return((BOOL)get(MUIA_Prop_Horiz,FALSE)); };
		void PSlider(const BOOL p) { set(MUIA_Prop_Slider,(ULONG)p); };
		BOOL PSlider() const { return((BOOL)get(MUIA_Prop_Slider,0L)); };
		void Visible(const LONG p) { set(MUIA_Prop_Visible,(ULONG)p); };
		LONG Visible() const { return((LONG)get(MUIA_Prop_Visible,0L)); };
		void Decrease(LONG p) { dom(MUIM_Prop_Decrease,(ULONG)p); };
		void Increase(LONG p) { dom(MUIM_Prop_Increase,(ULONG)p); };
	};

#endif
