//
//  $VER: Semaphore.h   1.2 (02 Sep 1996)
//
//    c 1996 Thomas Wilhelmi
//
//
// Address : Taunusstrasse 14
//           61138 Niederdorfelden
//           Germany
//
//  E-Mail : willi@twi.rhein-main.de
//
//   Phone : +49 (0)6101 531060
//   Fax   : +49 (0)6101 531061
//
//
//  $HISTORY:
//
//  16 Jun 1996 :   1.0 : first public Release
//
//  02 Sep 1996 :   1.2 : Neu:
//                        - ClassNum() fr Exception-Handling.
//                        nderungen
//                        - Parameter des Copy-Konstruktor als 'const'-Parameter definiert
//

#ifndef CPP_TWIMUI_SEMAPHORE_H
#define CPP_TWIMUI_SEMAPHORE_H

#ifndef CPP_TWIMUI_NOTIFY_H
#include <classes/twimui/notify.h>
#endif

class MUISemaphore : public MUINotify
	{
	protected:
		virtual const ULONG ClassNum() const;
		MUISemaphore(const STRPTR cl) : MUINotify(cl) { };
	public:
		MUISemaphore(const struct TagItem *t) : MUINotify(MUIC_Semaphore) { init(t); };
		MUISemaphore(const Tag, ...);
		MUISemaphore() : MUINotify(MUIC_Semaphore) { };
		MUISemaphore(const MUISemaphore &);
		virtual ~MUISemaphore();
		MUISemaphore &operator= (const MUISemaphore &p);
		void Attempt() { dom(MUIM_Semaphore_Attempt); };
		void AttemptShared() { dom(MUIM_Semaphore_AttemptShared); };
		void Obtain() { dom(MUIM_Semaphore_Obtain); };
		void ObtainShared() { dom(MUIM_Semaphore_ObtainShared); };
		void Release() { dom(MUIM_Semaphore_Release); };
	};

#endif
